/***************************************************************************
 *   Copyright (C) 2007 by Marco Brescianini   *
 *   marco454_36@hotmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef RSYNCWRAPPER_H
#define RSYNCWRAPPER_H

#include<QStringList>
#include<QThread>

static const QString program = "/usr/bin/rsync";

class RsyncWrapper : public QThread
{
	Q_OBJECT

    public:

	RsyncWrapper();
	~RsyncWrapper();
	
	void setArgs(const QStringList & argsList);
	
    signals:
	void dataReady(const QString & data);

    protected:
	void run();
	
    private:

	void clearArgs();

	QStringList* args;
};



#endif //multiple inclusion guard

